Titanium.include("caching.js");

Titanium.API.info("Initializing...");
	//This text is inserted before each HTML Table to make complete HTML Document & in the head there is META tag which tell the browser to use UTF-8 encoding
	var beforeHTML = "<html><head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"></head><body>";
	//The text witch is inserting after each HTML Table, is used to form complete HTML Document
	var afterHTML = "<br></body></html>";

	//calc the density ratio, default dpi is 160
	var ratio = (Titanium.Platform.displayCaps.dpi/160);
	
	var strCancel, strUP;
	var language = Titanium.App.Properties.getString("language", "en");
	Titanium.API.info("Language: " + language);
	if(language == "fo") {
		strCancel = "gera til einkis";
	    strUP = "UPP";
	} else if(language == "da") {
		strCancel = "Annuller";
		strUP = "OP";
	} else {
		strCancel = "Cancel";
		strUP = "UP";
	}
	var win = Titanium.UI.currentWindow;

	var pageid = win.header[0];
	var url = "http://www.62n.fo/Default.aspx?pageid=" + pageid;
	var contentID = "skn_lyut_ctr" + win.header[1];
	var title = win.header[2];

//////////////FUNCTIONS
	var show = function() {
        dialog.show();
    };
    
    var close = function() {
        if(Titanium.Platform.name == "iPhone OS") {
            win.hide();
        } else {
            win.close();
        }
    };
    
	var load = function() {		///load contents from web
		Titanium.API.info("Loading { 'pageid': " + pageid + "		url: " + url );

		lblLoading.setVisible(true);
		lblLoading.title = "Loading! Please wait...";
		try {
			var cached = getCached(pageid);
			if (cached != null) {
				var html = beforeHTML + cached + afterHTML;
				webview.html = html;
				webview.isLocal = true;
				lblLoading.setVisible(false);
			}
			else {
				var xhr = Titanium.Network.createHTTPClient({ timeout: 10000 });
				xhr.onload = function(){
					if (this.responseText) {
//						var start = this.responseText.indexOf("div id=\"" + contentID);
						var start = this.responseText.indexOf("td id=\"skn_lyut_ContentPane\"");
						var response = this.responseText.substring(start - 1);
						var end = response.indexOf("<td style=\"width:32px;\">");												//get only the table
						response = response.substring(0, end);
						Titanium.API.info("Content " + start + " " + end);
						
						response = response.replace(new RegExp("=\"/", "g"), "=\"http://www.62n.fo/");							//convert relative path to absolute
						response = response.replace(new RegExp("javascript:openPopWindow\\('/", "g"), "http://www.62n.fo/");	//convert Popup Windows to standard links
						response = response.replace(new RegExp("'\\);", "g"), "");
						
						addToCache(pageid, response);
//		!!!!! links for downloading files are not working on android.
//						if(Titanium.Platform.name == "android") {
//							var links = getDownloads(response);
//							
//							if(links != null) {
//								win.backgroundColor = "white";
//								var lbl = Titanium.UI.createLabel({
//									title: "Click on the links below to download document",
//										top: 20,
//										color: 'black',
//										fontWeight:'bold'
//									});
//								win.add(lbl);
//								for(var i=0;i<links.length;i++) {
//									lbl = Titanium.UI.createLabel({
//										title: links[i].title,
//										url: links[i].url,
//										top: ((i*30) + 50),
//										color: 'blue'
//									});
//									lbl.addEventListener("click", onLinkClick);
//									win.add(lbl);
//								}
//								lblLoading.setVisible(false);
//								webview.setVisible(false);
//								return;
//							}
//						}
						response = beforeHTML + response + afterHTML;
					}
					else {
						response = beforeHTML + "<center>Unable to load content.\nPlease check your internet connection and try again.</center>" + afterHTML;
					}
                    webview.isLocal = true;
					webview.html = response;
				};
				xhr.onerror = function() { throw "An error occurred while loading data from web. Please try again later!"; };
				xhr.open("GET", url);
				xhr.send();
			}
	    }
	    catch (err) {
	        lblLoading.title = String(err);
	    }
	};
    
	
	function getDownloads(html) {
		var r = [];
		var s = 0;
		var i = 0;
		var url, title;
		while((s = html.indexOf("href=\"")) != -1) {
			html = html.substring(s + 6);
			var e = html.indexOf("\"");
			title = url = html.substring(0, e).replace(new RegExp(" ", "g"), "");
			if (url.indexOf("mail") != -1) {
				return null;
			}
			while (html.length > 10) {
				var re = new RegExp(">(.*)\\) *<");
				var x = re.exec(html);
				if (x != null) {
					html = html.replace(new RegExp(".*>(.*)\\) *<"), "");
					title = x[1] + ')';
				}
				break;
			}
			r[i++] = { url: url, title: title };
		}
		if (i == 0) {
			return null;
		}
		else {
			return r;
		}
	};

////////END functions


	
/////////////EVENT LISTENERS
	var onClose = function(e){
		webview.stopLoading();
	};
    
    var onOpen = function(e) {
        if(win.winToClose) {
            if(Titanium.Platform.name == "iPhone OS") {
                win.winToClose.hide();
            } else {
                win.winToClose.close();
            }
        }
		
		load();
    };
	
	var onLinkClick = function(e) {
		Titanium.Platform.openURL(e.source.url);
	};
	
	var onWebLoad = function(e) {
		Titanium.API.info("onWebLoad");

		lblLoading.setVisible(false);
        if(!webview.isLocal) {
            btBack.setVisible(true);
            btCurrent.setVisible(false);
            btLeft.setVisible(false);
            btRight.setVisible(false);
        } else {
            webview.isLocal = false;
            btCurrent.setVisible(true);
            btLeft.setVisible(true);
            btRight.setVisible(btRight.isVisible);
            btBack.setVisible(false);
        }
 	};
	
	var onBackButton = function(e){
		Titanium.API.info("onBackButton");

		win.remove(webview);
		webview = null;
		webview = Titanium.UI.createWebView({
			bottom: 46*ratio
		});
		win.add(webview);
		webview.addEventListener('load', onWebLoad);
		load();
		btCurrent.setVisible(true);
		btLeft.setVisible(true);
		btRight.setVisible(btRight.isVisible);
		btBack.setVisible(false);
	};

	var onNavButton = function(e){
		Titanium.API.info("onNavButton");
		
		var i = e.source.myIndex;
		var header = win.parentMenu.headers[i];
		header[2] = win.parentMenu.titles[i];
		
		var childs = win.parentMenu.childs;
		if (childs != null) {
			childs = childs[i];
		}
		
		var newWin = Titanium.UI.createWindow({
			url: "Window62n.js",
			header: header,
			backgroundColor: '#eeeeee',
			title: win.parentMenu.titles[i]
		});
		
		if (childs != null) {
			newWin.menu = childs;
		}
		newWin.parentMenu = win.parentMenu;
		newWin.thisIndex = i;
                
		newWin.open({
			fullscreen: true,
			modalStyle: Ti.UI.iPhone.MODAL_PRESENTATION_FULLSCREEN,
			modal:true,
			navBarHidden:true
		});
		if (Titanium.Platform.name == "android") {
			win.close();
		}
		else {
			newWin.winToClose = win;
		}
      
	};

	var onDialogItem = function(e){
		Titanium.API.info("onDialogItem");

		if (e.index == e.cancel) {
			return;
		}
		if (e.index == 0) {
			close();
		}
		else {
			var i = (e.index - 1);
			
			var childs = win.menu.childs;
			if (childs != null) {
				childs = childs[i];
			}
			var header = win.menu.headers[i];
			header[2] = win.menu.titles[i];
			
			var newWin = Titanium.UI.createWindow({
				url: "Window62n.js",
				backgroundColor: '#dddddd',
				header: header,
				title: win.menu.titles[i]
			});
			
			if (childs != null) {
				newWin.menu = childs;
			}
			newWin.parentMenu = win.menu;
			newWin.thisIndex = i;
			newWin.open({
				fullscreen: true,
				modalStyle: Ti.UI.iPhone.MODAL_PRESENTATION_FULLSCREEN,
				modal:true,
				navBarHidden:true
			});
		}
	};
	
////////END event listeners
	
	
	
	

	
///////////CREATING WINDOW
	Titanium.API.info("Creating new window... [" + this + "]");

	win.backgroundColor = "#dddddd";
	///WEB VIEW
	var webview = Titanium.UI.createWebView({
		bottom: 46*ratio,
		navBarHidden: true
	});
	/////---
	
	//MENU DIALOG
    dialog = Titanium.UI.createOptionDialog({
		title: 'Menu:',
		cancel: -1
	});

    var options = [strUP];
    if (win.menu != null) {
		var l = win.menu.titles.length;
		for (var i = 0; i < l; i++) {
			options[i + 1] = win.menu.titles[i];
		}
	}

	dialog.cancel = options.length;
    if (Titanium.Platform.name == 'iPhone OS') {
		options[dialog.cancel] = strCancel;
	}
	dialog.options = options;
	
	dialog.addEventListener("click", onDialogItem);
	////
	
	btRight = Titanium.UI.createButton({ backgroundImage: "images/right.png", right: 5*ratio, bottom: 3*ratio, width: 45*ratio, height: 40*ratio });
	btLeft = Titanium.UI.createButton({ backgroundImage: "images/left.png", left: 5*ratio, bottom: 3*ratio, width: 45*ratio, height: 40*ratio });
	btCurrent = Titanium.UI.createButton({ backgroundImage: "images/button.png", title: title, font:{ fontFamily:'Helvetica Neue' }, color: "#222222", left: 60*ratio, bottom: 3*ratio, right: 60*ratio, height: 40*ratio });
	
	btCurrent.addEventListener("click", show);
	
	if (win.parentMenu != null) {
		if (win.thisIndex > 0) {
			btLeft.myIndex = win.thisIndex - 1;
			btLeft.addEventListener("click", onNavButton);
		}
		else {
			btLeft.backgroundImage = "images/up.png";
			btLeft.addEventListener("click", close);
		}
		
		if (win.thisIndex < (win.parentMenu.headers.length - 1)) {
			btRight.myIndex = win.thisIndex + 1;
			btRight.addEventListener("click", onNavButton);
		}
		else {
			btRight.isVisible = false;
			btRight.setVisible(false);
		}
	}
	else {
		btRight.isVisible = false;
		btRight.setVisible(false);
		btLeft.backgroundImage = "images/up.png";
		btLeft.addEventListener("click", close);
	}
	
	lblLoading = Titanium.UI.createLabel({
		title: 'Loading! Please wait.',
		font: {
			fontSize: 14,
			fontWeight: 'bold'
		}
	});

	btBack = Titanium.UI.createButton({ title: "Back", font:{ fontFamily:'Helvetica Neue' }, left: 100*ratio, bottom: 3*ratio, right: 100*ratio, height: 40*ratio, visible: false });
	btBack.addEventListener("click", onBackButton);
    if(Titanium.Platform.name == "android") {
        btRight.borderWidth = 2;
        btLeft.borderWidth = 2;
        btCurrent.borderWidth = 2;
        btBack.borderWidth = 2;
    }
	webview.addEventListener('load', onWebLoad);
	//webview.addEventListener('error', onWebLoad);
	
	win.addEventListener("close", onClose);
	win.addEventListener("open", onOpen);
    
    win.add(webview);
	win.add(btCurrent);
	win.add(btLeft);
	win.add(btRight);
	win.add(lblLoading);
	win.add(btBack);

///////END CREATING WINDOW
Titanium.API.info("Done.");
	
